#include "ofApp.h"

//--------------------------------------------------------------
void ofApp::setup(){
    ofEnableDepthTest();
    
    // Change string "/dev/somthing" to the Serial port of your arduino
	//serial.setup("COM5", 9600);
    arduino.connect("COM5", 57600);
	arduino.sendFirmwareVersionRequest();
    // Check if Arduino is ready to be setup
    ofAddListener(arduino.EInitialized, this, &ofApp::setupArduino);
    bSetupArduino = false;
}

//--------------------------------------------------------------
void ofApp::setupArduino(const int & version) {
    //Remove listener and setup arduino
    ofRemoveListener(arduino.EInitialized, this, &ofApp::setupArduino);
    bSetupArduino = true;

    // Setup pins here! //
    // set pin D13 as digital output for LED
	arduino.sendDigitalPinMode(6, ARD_OUTPUT);
   }

//--------------------------------------------------------------
void ofApp::update() {
    //Update the arduino to get data/ messages
    arduino.update();
    
    //Do not send anything until the arduino is setup
    if(bSetupArduino){
        //Things we are sending!
        //Potinput = arduino.getAnalog(1);
		//arduino.sendPwm(6, (int)(128 + 128 * sin(ofGetElapsedTimef())));
      
    }

    
}

//--------------------------------------------------------------
void ofApp::draw(){
    ofBackground(255);
    
    displayArduinoData();
  

    

}

//--------------------------------------------------------------
void ofApp::displayArduinoData() {
    
    ofSetColor(0, 0, 0);
    if(!bSetupArduino){
        ofDrawBitmapString("not ready...\n", 100, 50);
    } else {
        ofDrawBitmapString("ready", 100, 50);
        // print input values etc.
          }
}

//--------------------------------------------------------------
void ofApp::keyPressed(int key) {
	if (bSetupArduino) {
		if (key == '1') {
			//arduino.sendByte(3);
			arduino.sendByte(0);
			arduino.sendByte(0);
			arduino.sendByte(0);
			arduino.sendDigital(6, 1);
			//arduino.sendByte(1);
			//arduino.sendPwm(6, (int)(128 + 128 * sin(ofGetElapsedTimef())));
			
		}
		
            // turn led on here
   
    }
}

//--------------------------------------------------------------
void ofApp::keyReleased(int key){
    if(bSetupArduino) {
        if (key == '1'){
            // turn led off here
              arduino.sendDigital(6, 0);
		
        }
    }
}

//--------------------------------------------------------------
void ofApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void ofApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void ofApp::mouseReleased(int x, int y, int button){

}
