//
//  Circle class.cpp
//  Visual CP 1
//
//  Created by james carty on 08/02/2018.
//

#include "Circle class.hpp"

void CircleClass::setup(){
    circleParams.add(circleRes.set("res", 60, 3, 60));
    circleParams.add(release.set("release",0.3, 0.0, 1.0));
    circleParams.add(size.set("size",9.0, 0.0, 30.0));
    
     circleParams.add(posX.set("posX",0, -900, 900));
     circleParams.add(posY.set("posY",0, -900, 900));
    
    circleParams.add(rotateX.set("rotX",0.0, -1.0, 1.0));
    circleParams.add(rotateY.set("rotY",0.0, -1.0, 1.0));
    circleParams.add(rotateZ.set("rotZ",0.0, -1.0, 1.0));
    
      circleParams.add(red.set("red", 255, 0, 255));
      circleParams.add(green.set("Green", 255, 0, 255));
      circleParams.add(blue.set("Blue", 255, 0, 255));
      circleParams.add(alpha.set("Alpha", 255, 0, 255));
    
    fftSmooth = new float [8192]; //smooth out signal
    for (int i = 0; i < 8192; i++){
        fftSmooth[i] = 0;
    }
    bands = 64;
}

void CircleClass::update(){
    rotationX = rotationX + rotateX;
    rotationY = rotationY + rotateY;
    rotationZ = rotationZ + rotateZ;
    
//Ensure we are updating our spectrum
    
    float * value = ofSoundGetSpectrum(bands);
    for (int i = 0; i < bands; i++){
        fftSmooth[i] *= release; //how quick or slow the shapes die down
        if (fftSmooth[i] < value[i]){
            fftSmooth[i] = value[i];
        }
    }
}
//Push and pop to create the shapes as its own object
void CircleClass::draw(){
    ofPushMatrix();
    ofSetCircleResolution(circleRes);
    for (int i = 0; i < bands; i++){
        ofTranslate(ofGetWidth()/2, ofGetHeight()/2);  //circle will move (radius of shape)
        ofRotateX(rotationX);
        ofRotateY(rotationY);
        ofRotateZ(rotationZ);
        ofSetColor(red, green, blue, alpha);
        ofCircle(posX, posY, -(fftSmooth[i] * 60) * size);
    }
    ofPopMatrix();
    
    
}
